
import java.util.Comparator;

/**
   Voter objects can be sorted
     by lastName, firstname, state, age, or
     by state, age, lastName, firstName, or
     by age, state, lastName, firstName.

   Which state has the most voters?
   Which state has the most 20 year olds?
   Which last name is most common?
   Do we need to sort the data to answer these questions?
*/
public class Voter
{
   public String firstName;
   public String lastName;
   public int age;
   public String state;
}



class VoterComparator1 implements Comparator<Voter>
{
   @Override public int compare(Voter first, Voter second)
   {
      if (! first.lastName.equals(second.lastName))
      {
         return first.lastName.compareTo(second.lastName);
      }
      else if (! first.firstName.equals(second.firstName))
      {
         return first.firstName.compareTo(second.firstName);
      }
      else if (! first.state.equals(second.state))
      {
         return first.state.compareTo(second.state);
      }
      else
      {
         return first.age - second.age;
      }
   }
}


class VoterComparator2 implements Comparator<Voter>
{
   @Override public int compare(Voter first, Voter second)
   {
      if (! first.state.equals(second.state))
      {
         return first.state.compareTo(second.state);
      }
      else if (first.age != second.age)
      {
         return first.age - second.age;
      }
      else if (! first.lastName.equals(second.lastName))
      {
         return first.lastName.compareTo(second.lastName);
      }
      else
      {
         return first.firstName.compareTo(second.firstName);
      }
   }
}
