
// Two generic interface definitions.
// They each have a type varible E.

interface Comparable<E>
{
   public int compareTo(E that);
}


interface Comparator<E>
{
   public int compare(E first, E second);
}


// https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/lang/Comparable.html

// https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/util/Comparator.html
